]>
git.madduck.net Git - code/vcsh.git/blobdiff - vcsh
madduck's git repository
Every one of the projects in this repository is available at the canonical
URL git://git.madduck.net/madduck/pub/<projectpath> — see
each project's metadata for the exact URL.
All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@ git. madduck. net .
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
SSH access, as well as push access can be individually
arranged .
If you use my repositories frequently, consider adding the following
snippet to ~/.gitconfig and using the third clone URL listed for each
project:
[url "git://git.madduck.net/madduck/"]
insteadOf = madduck:
VERSION='1.20141026'
SELF=$(basename $0)
VERSION='1.20141026'
SELF=$(basename $0)
+# Ensure all files created are accessible only to the current user.
+umask 0077
+
fatal() {
echo "$SELF: fatal: $1" >&2
[ -z $2 ] && exit 1
fatal() {
echo "$SELF: fatal: $1" >&2
[ -z $2 ] && exit 1
commit Commit in all repositories
delete <repo> Delete an existing repository
enter <repo> Enter repository; spawn new instance of \$SHELL
commit Commit in all repositories
delete <repo> Delete an existing repository
enter <repo> Enter repository; spawn new instance of \$SHELL
foreach [<-g>]
<git command> Execute a command for every repository
help Display this help text
foreach [<-g>]
<git command> Execute a command for every repository
help Display this help text
You should add files to your new repository."
exit
fi
You should add files to your new repository."
exit
fi
- git fetch origin "$VCSH_BRANCH"
+ GIT_VERSION_MAJOR=$(git --version | sed -E -n 's/.* ([0-9]+)\..*/\1/p' )
+ if [ 1 -lt "$GIT_VERSION_MAJOR" ];then
+ git fetch origin "$VCSH_BRANCH"
+ else
+ git fetch origin
+ fi
hook pre-merge
git ls-tree -r --name-only origin/"$VCSH_BRANCH" | (while read object; do
[ -e "$object" ] &&
hook pre-merge
git ls-tree -r --name-only origin/"$VCSH_BRANCH" | (while read object; do
[ -e "$object" ] &&
commit() {
hook pre-commit
commit() {
hook pre-commit
+ shift # remove the "commit" command.
for VCSH_REPO_NAME in $(list); do
echo "$VCSH_REPO_NAME: "
GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
use
for VCSH_REPO_NAME in $(list); do
echo "$VCSH_REPO_NAME: "
GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
use
- git commit --untracked-files=no --quiet
+ git commit --untracked-files=no --quiet "$@"
VCSH_COMMAND_RETURN_CODE=$?
echo
done
VCSH_COMMAND_RETURN_CODE=$?
echo
done
[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+ git init --shared=false
get_files() {
GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
get_files() {
GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ git ls-files --full-name
use
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
use
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+ local GIT_VERSION="$(git --version)"
+ local GIT_VERSION_MAJOR=$(echo $GIT_VERSION | sed -E -n 's/.* ([0-9]+)\..*/\1/p')
+ local GIT_VERSION_MINOR=$(echo $GIT_VERSION | sed -E -n 's/.* ([0-9]+)\.([0-9]+)\..*/\2/p')
OLDIFS=$IFS
IFS=$(printf '\n\t')
gitignores=$(for file in $(git ls-files); do
OLDIFS=$IFS
IFS=$(printf '\n\t')
gitignores=$(for file in $(git ls-files); do
- while true; do
- echo "$file"; new=${file%/*}
- [ x"$file" = x"$new" ] && break
- file=$new
- done;
+ if [ $GIT_VERSION_MAJOR -ge 2 -a $GIT_VERSION_MINOR -ge 7 ]; then
+ echo "$file";
+ else
+ while true; do
+ echo "$file"; new=${file%/*}
+ [ x"$file" = x"$new" ] && break
+ file=$new
+ done;
+ fi
done | sort -u)
# Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
done | sort -u)
# Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files